%define	snap	20050412

%define	name	olfix
%define	version	0.2.3.B
%define	release 0.%{snap}.1mdk

Summary:	An administrative system for small to medium sized companies
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		Graphical desktop/KDE
URL:		http://www.shellkonto.nu/olfix/
Source0:	OLFIX-%{version}-%{snap}.tar.bz2
Source1:	olfix.png
BuildRequires:	file
BuildRequires:	MySQL-devel
BuildRequires:	libqt-devel
BuildRequires:	XFree86-devel
BuildRequires:	XFree86-libs
BuildRequires:	kdelibs-devel
BuildRequires:	kdelibs-common >= 3.1.93-5mdk
Buildroot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
An administrative system for small to medium sized companies. It
will contain functionality for order, inventory and billing as
well as bookkeeping. It is primarily aimed at european users.

Currently the OLFIX suite supports Swedish only.

%prep

%setup -q -n OLFIX-%{version}-%{snap}

cp %{SOURCE1} .

# fix paths
find -type f | xargs perl -pi -e "s|/usr/local/olfix/data|%{_datadir}/olfix/data|g"
find -type f | xargs perl -pi -e "s|/usr/local/olfix/sql|%{_datadir}/olfix/sql|g"
find -type f | xargs perl -pi -e "s|/usr/local/olfix/report|%{_datadir}/olfix/report|g"
find -type f | xargs perl -pi -e "s|/opt/olfix/data|%{_datadir}/olfix/data|g"
find -type f | xargs perl -pi -e "s|/opt/olfix/sql|%{_datadir}/olfix/sql|g"
find -type f | xargs perl -pi -e "s|/opt/olfix/report|%{_datadir}/olfix/report|g"
find -type f | xargs perl -pi -e "s|/opt/olfix|%{_datadir}/olfix|g"

# fix paths here too
find src -type f -name "*.h" | xargs perl -pi -e "s|\./||g"
find src -type f -name "*.c" | xargs perl -pi -e "s|\./||g"
find src -type f -name "*.cpp" | xargs perl -pi -e "s|\./||g"

# fix target
mkdir -p KDE_BINARIES
DESTDIR="../../KDE_BINARIES"
find src -type f -name "*.pro" | xargs perl -pi -e "s|^DESTDIR\\+=.*|DESTDIR\\+=${DESTDIR}|g"

%build
export QTDIR=%{_prefix}/lib/qt3
export KDEDIR=%{_prefix}
export LD_LIBRARY_PATH="$QTDIR:/%{_lib}:$LD_LIBRARY_PATH"
export PATH="$KDEDIR/bin:$PATH"

pushd src
    %make GCC="gcc" CC="gcc" CFLAGS="%{optflags} -I%{_includedir}/mysql" OLFIXDEST=%{_prefix} \
    OLFIXBIN="." OLFIXSRC="." LDFLAGS="-L%{_libdir}/mysql" LDLIBS="-lmysqlclient" \
    PROGRAMS=`ls -1 *.c|sed 's/\.c//'`
popd

pushd src
    prg=`find . -type d | sed "s/\.\///g" | grep -v "^\."`
    for i in $prg; do
	pushd ${i}
	    if [ -f Makefile ]; then
		PRO_NAME=`find . -name '*.pro'`
		if ! [ -z "${PRO_NAME}" ]; then
		    NEW_PRO_NAME=`echo "${PRO_NAME}"| sed -e "s/^\.\///"`
		    if ! [ "${NEW_PRO_NAME}" = "${i}.pro" ]; then
			cp ${NEW_PRO_NAME} ${i}.pro
    		    fi
		fi
		make clean; qmake -makefile ${i}.pro
		%make GCC="gcc" CC="gcc" CFLAGS="%{optflags}" CXXFLAGS="%{optflags}"
	    fi
	popd
    done
popd

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
#export DONT_STRIP=1

install -d %{buildroot}%{_datadir}/olfix/{data,report,script,sql}
install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_iconsdir}
install -d %{buildroot}%{_miconsdir}
install -d %{buildroot}%{_liconsdir}
install -d %{buildroot}%{_menudir}

# install binaries
prg=`find src -type f | xargs file | grep "ELF" | grep "executable" | cut -d: -f1`
for i in $prg; do
    install -m0755 ${i} %{buildroot}%{_bindir}/
done

# install KDE binaries
install -m0755 KDE_BINARIES/* %{buildroot}%{_bindir}/

# fix some icons
install -m0644 olfix.png %{buildroot}%{_liconsdir}/%{name}.png
convert olfix.png -geometry 16x16 %{buildroot}%{_miconsdir}/%{name}.png
convert olfix.png -geometry 32x32 %{buildroot}%{_iconsdir}/%{name}.png

# fix mandrake menu entry
cat >> %{buildroot}%{_menudir}/%{name} << EOF
?package(%{name}): \
 command="%{_bindir}/OLFIXW" \
 icon="%{name}.png" \
 needs="X11" \
 section="Applications/Finances" \
 title="OLFIXW" \
 longtitle="OLFIX - Order/Lager/Fakturering fr Linuxsystem"
EOF

# install other stuff
install -m0644 data/* %{buildroot}%{_datadir}/olfix/data/
install -m0644 report/* %{buildroot}%{_datadir}/olfix/report/
install -m0644 script/* %{buildroot}%{_datadir}/olfix/script/
install -m0644 sql/* %{buildroot}%{_datadir}/olfix/sql/

# fix manual
cp -rp doc/helpfiles/usermanual manual
ln -snf %{_docdir}/%{name}-%{version}/manual %{buildroot}%{_datadir}/olfix/manual

# fix .olfixrc
cat > .olfixrc << EOF
PATH=%{_bindir}/
HOST=localhost
DATABASE=olfixtst
HELPFILE=/share/olfix/manual/UserManual.html
REPORT=%{_datadir}/olfix/report/
VTMP=/tmp/
EOF
install -m0644 .olfixrc %{buildroot}%{_datadir}/olfix/script/

#%%pre
#%%_pre_useradd %{name} %{_datadir}/%{name} /bin/sh

%post
%update_menus

%postun
#%%_postun_userdel %{name}
%clean_menus

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc doc/*.txt doc/README* doc/*.pdf Changelog.txt manual
%{_bindir}/*
%{_datadir}/olfix
%{_menudir}/%{name}
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png

%changelog
* Tue Apr 12 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 0.2.3.B-0.20050412.1mdk
- 0.2.3.B (CVS 20050412)

* Tue Nov 16 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.1.16a-0.20041115.1mdk
- 0.1.16a (20041115)
- fixed P0

* Thu Nov 11 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.1.16a-0.20041111.1mdk
- 0.1.16a (20041110)
- fixed P0
- dropped the target patch

* Wed Nov 10 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.1.16a-0.20041110.1mdk
- 0.1.16a (20041110)
- fixed P0 and P1

* Tue Nov 09 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.1.15a-0.20041107.2mdk
- fixed P0
- added P1

* Sun Nov 07 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.1.15a-0.20041107.1mdk
- 20041107

* Fri Nov 05 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.1.15a-0.20041029.2mdk
- added P0 to address CAPITAL file names

* Fri Oct 29 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.1.15a-0.20041029.1mdk
- 20041029

* Thu Oct 21 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.1.15a-0.20040503.1mdk
- initial mandrake package
